/*
 * LabelBox.h
 *
 *  Created on: Oct 27, 2008
 *      Author: dustin
 */

#ifndef LABELBOX_H_
#define LABELBOX_H_

#include <gtkmm/container.h>

namespace UI {

namespace Component {

class LabelBox : public Gtk::Container
{
public:
	LabelBox();
	virtual ~LabelBox();

	virtual void set_child_widgets(Gtk::Widget& child);
	void setFillColor(const Gdk::Color & color);
	void setBorderColor(const Gdk::Color & color);
	void setFillAlpha(double alpha);
	void setBorderWidth(double width);
	void setCornerRadius(double radius);
	void setPadding(double paddingTop, double paddingBottom, double paddingLeft, double paddingRight);
	void setPadding(double padding);

protected:

	//Overrides:
	virtual void on_size_request(Gtk::Requisition* requisition);
	virtual void on_size_allocate(Gtk::Allocation& allocation);
	virtual void on_map();
	virtual void on_unmap();
	virtual void on_realize();
	virtual void on_unrealize();
	virtual bool on_expose_event(GdkEventExpose* event);

	virtual void forall_vfunc(gboolean include_internals, GtkCallback callback, gpointer callback_data);

	virtual void on_add(Gtk::Widget* child);
	virtual void on_remove(Gtk::Widget* child);
	virtual GtkType child_type_vfunc() const;

	Glib::RefPtr<Gdk::Window> m_refGdkWindow;
	Gtk::Widget* m_child;

	double cornerRadius, strokeWidth,
		padding_top, padding_bottom,
		padding_left, padding_right;
	Gdk::Color fillColor, strokeColor;
	double alpha;

};

}

}

#endif /* LABELBOX_H_ */
