//$Id: examplewindow.cc 341 2005-01-18 20:52:18Z murrayc $ -*- c++ -*-

/* gtkmm example Copyright (C) 2004 gtkmm development team
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "examplewindow.h"

ExampleWindow::ExampleWindow()
: table(2,2),
  lbl1("Label 1"),
  lbl2("Label 2"),
  lbl3("Label 3"),
  lbl4("Label 4"),
  m_Button_Quit("Quit")
{
  set_title("Custom Widget example");
  set_border_width(6);
  set_default_size(400, 200);

  add(m_VBox);

	labelbox1.setPadding(10);
	labelbox1.setFillAlpha(0.5);
	labelbox1.setCornerRadius(10);
	labelbox1.setBorderWidth(4);
	labelbox1.add(lbl1);
	table.attach(labelbox1, 0, 1, 0, 1);

	labelbox2.setPadding(10);
	labelbox2.setFillAlpha(0.5);
	labelbox2.setCornerRadius(10);
	labelbox2.setBorderWidth(6);
	labelbox2.setFillColor(Gdk::Color("red"));
	labelbox2.setBorderColor(Gdk::Color("red"));
	labelbox2.add(lbl2);
	lbl2.show();
	table.attach(labelbox2, 1, 2, 0, 1);

	labelbox3.setPadding(10);
	labelbox3.setFillAlpha(0.5);
	labelbox3.setCornerRadius(10);
	labelbox3.setBorderWidth(8);
	labelbox3.setFillColor(Gdk::Color("yellow"));
	labelbox3.setBorderColor(Gdk::Color("yellow"));
	labelbox3.add(lbl3);
	table.attach(labelbox3, 0, 1, 1, 2);

	labelbox4.setPadding(10);
	labelbox4.setFillAlpha(0.5);
	labelbox4.setCornerRadius(10);
	labelbox4.setBorderWidth(10);
	labelbox4.setFillColor(Gdk::Color("green"));
	labelbox4.setBorderColor(Gdk::Color("green"));
	labelbox4.add(lbl4);
	table.attach(labelbox4, 1, 2, 1, 2);

  m_VBox.pack_start(table, Gtk::PACK_EXPAND_WIDGET);

  m_VBox.pack_start(m_ButtonBox, Gtk::PACK_SHRINK);

  m_ButtonBox.pack_start(m_Button_Quit, Gtk::PACK_SHRINK);
  m_ButtonBox.set_border_width(6);
  m_ButtonBox.set_layout(Gtk::BUTTONBOX_END);
  m_Button_Quit.signal_clicked().connect( sigc::mem_fun(*this, &ExampleWindow::on_button_quit) );

  show_all_children();
}

ExampleWindow::~ExampleWindow()
{
}

void ExampleWindow::on_button_quit()
{
  hide();
}
